'
'*******************************************************************************
' LED-Uhrenwecker fr Netzbetrieb mit minimalem Strombedarf und Gangreserve
' (C) 2007/2008 V1.0 Julien Thomas
'*******************************************************************************
'
$regfile = "attiny2313.dat"                       'Controller ATtiny2313
$crystal = 3276800                                'Basisfrequenz 3,276800 MHz
'
' Arbeitsvariable
Dim A As Byte
Dim B As Byte
Dim C As Byte
Dim Digit As Byte                                 'Aktuelle Ziffer
Dim Segbyte As Byte                               'Siegensegment-Bitmuster
Dim Blinkside As Byte                             'Position der Blinkziffer
Dim Dimmer As Byte                                'Dimmfaktor
'
Dim Astat As Byte                                 'Alarmstatus (Wecker an/aus)
Dim Alarm As Byte                                 'Alarm-Aktivierung (Weckton ein/aus)
Dim Asnze As Byte                                 'Schlummerfunktion aktiviert
'
Dim Dcntr As Byte                                 'Interner Taktzhler
Dim Point As Byte                                 'Position Dezimalpunkt
Dim Secs As Byte                                  'Sekundenzhler
'
Dim Di1 As Byte                                   'Display-Variable
Dim Di2 As Byte
Dim Di3 As Byte
Dim Di4 As Byte
'
Dim Ti1 As Byte                                   'Zeitvariable
Dim Ti2 As Byte
Dim Ti3 As Byte
Dim Ti4 As Byte
'
Dim Al1 As Byte                                   'Weckzeitvariable
Dim Al2 As Byte
Dim Al3 As Byte
Dim Al4 As Byte
Dim Al4tmp As Byte                                'Schlummer-Minuten
'
'
'Ausgnge
Z1 Alias Portd.0
Z2 Alias Portd.1
Z3 Alias Portd.2
Z4 Alias Portd.3
Buzzer Alias Portd.6
'
'
'Eingnge
Button Alias Pind.5
Mains Alias Pind.4
'
'
'Festwerte
Const Ein = &B10101010
Const Aus = &B01010101
'
Const Timer1preset = 51198                        '1 Hz @ 3276800 Hz / 64  (51200)
Const Dimnight = 31
Const Dimbright = 3
Const Dimnormal = 7
'
'
'-------------------------------------------------------------------------------
' Portbelegung in der Ausetzuhr-Schaltung fr AT90S2313 / Attiny 2313
'-------------------------------------------------------------------------------
'
' PB0-7  : Siebensegmentanzeige Kathoden a-g + Dezimalpunkt
'
' PD0    : Siebensegmentanzeige Anode 4. Ziffer (Minuten Einer)
' PD1    : Siebensegmentanzeige Anode 3. Ziffer (Minuten Zehner)
' PD2    : Siebensegmentanzeige Anode 2. Ziffer (Stunden Einer)
' PD3    : Siebensegmentanzeige Anode 1. Ziffer (Stunden Zehner)
'
' PD4    : Sensoreingang "Ausetzspannung" ( 1 = Ein, 0 = Aus )
' PD5    : Druckknopf (Schlieer) gegen Masse ( 0 = gedrckt )
' PD6    : Buzzer oder Speaker
'
'
'-------------------------------------------------------------------------------
' INITIALISIERUNGEN
'-------------------------------------------------------------------------------
Init:
'
' I/O - Voreinstellungen
 Ddrb = &B11111111
 Ddrd = &B00001111
 Portd = &B00100000
'
' Betriebsspannung abwarten (ergnzend zu BOD)
While Button = 0 : Wend
Wait 10
'
' Alarmregister vorbelegen
Astat = Aus
Alarm = Aus
Asnze = Aus
Blinkside = 4
Al2 = 8
'
' Timer0 = Anzeigetreiber
On Timer0 Siebensegment
Config Timer0 = Timer , Prescale = 8
Enable Timer0
'
' Timer 1 = Zeitbasis
On Timer1 Secs_tick
Config Timer1 = Timer , Prescale = 64
Enable Timer1
'
Enable Interrupts
'
'
'-------------------------------------------------------------------------------
' HAUPTPROGRAMM
'-------------------------------------------------------------------------------
'
Main:
'
Do                                                'Beginn Hauptschleife
'
'Aktuelle Zeit anzeigen
Gosub Showtime
'
'Alarmbedingungen prfen
If Alarm = Ein Then Gosub Alarmcheck
'
'Anzeige zwischen 20.00 Uhr und 9.59 Uhr dimmen
If Ti1 = 1 Then Dimmer = Dimnormal Else Dimmer = Dimnight
'
'Auf Knopfdrcke reagieren
If Button = 0 Then
   Dimmer = Dimbright
   Gosub Checkbutton
   If A = 100 Then Gosub Functionsmenu Else Gosub Alarmstatus
End If
'
Loop                                              'Ende Hauptschleife (endlos)
'
'
'
'-------------------------------------------------------------------------------
' Nutzroutinen
'-------------------------------------------------------------------------------
Showtime:                                         'Regulre Zeit
Di1 = Ti1 : Di2 = Ti2 : Di3 = Ti3 : Di4 = Ti4     'auf Display legen
If Secs.0 = 1 Then Point = 1 Else Point = 4       'Sekundenblinker
Return
'
Showalarmtime:
Point = 1                                         'Punkt permanent anzeigen
Di1 = Al1 : Di2 = Al2 : Di3 = Al3 : Di4 = Al4     'Alarmzeit auf Display
Return
'
Pause:                                            'Standardverzgerung
Wait 2                                            'GOSUBs sparen Speicher
Return                                            'gegenber Inline-WAITs !
'
Cleardis:
Point = 4                                         'Keinen Punkt anzeigen
Blinkside = 4                                     'Blinker aus
Di1 = 10 : Di2 = 10 : Di3 = 10 : Di4 = 10         'Display dunkelschalten
Return
'
X_off:
Gosub Cleardis
Di2 = 00 : Di3 = 11 : Di4 = 11                    'Anzeige ' OFF'
Return
'
X_on:
Gosub Cleardis
Di2 = 10 : Di3 = 16 : Di4 = 17                    'Anzeige '  on'
Return
'
X_set:
Gosub Cleardis
Di2 = 05 : Di3 = 14 : Di4 = 15                    'Anzeige ' SET'
Return
'
'
'
'-------------------------------------------------------------------------------
' Tastendrcke auswerten, Rckgabewert A fr kurz oder lang
'-------------------------------------------------------------------------------
'
Checkbutton:
A = 0
While Button = 0
Waitms 15 : Incr A : If A = 100 Then Return
Wend
Return
'
Checkpause:
A = 0
While Button = 1
Waitms 15 : Incr A : If A = 100 Then Return
Wend
Return
'
'
'
'-------------------------------------------------------------------------------
' Alarmfunktionen  (Aufruf wenn Alarmbedingung erfllt)
'-------------------------------------------------------------------------------
'
Alarmcheck:
Dimmer = Dimbright
While Al4tmp = Ti4                                'Eine Minute laufen lassen
Gosub Showtime                                    'Aktuelle Zeit anzeigen
If Button = 0 Then Goto Alarm_react               'und auf Knopfdruck warten
Wend
'
Alarm_react:
Astat = Aus                                       'Alarmstatus und akustischer
Gosub Checkbutton
If A = 100 Then Goto Alarm_off                    'Langer Knopfdruck = Alarm Aus
'
Alarm_snooze:
Gosub Cleardis
Di1 = 05 : Di2 = 17 : Di3 = 02                    'Anzeige 'SnZ '
Gosub Pause
Al4tmp = Al4tmp + 7                               '7 Schlummerminuten addieren
If Al4tmp > 9 Then Al4tmp = Al4tmp - 10           'nur Minutenregister modulo 10
Asnze = Ein                                       'Schlummerfunktion aktivieren
Goto Alarm_reactivate
'
'
Alarm_off:
Asnze = Aus
Al4tmp = Al4                                      'Alarmminute wiederherstellen
Gosub X_off                                       'Anzeige ' OFF'
Gosub Pause
Gosub Pause
While Al4tmp = Ti4
Gosub Showtime
Wend
'
Alarm_reactivate:
Astat = Ein
Return
'
'
'
'-------------------------------------------------------------------------------
' Alarmstatus anzeigen (Anzeige Zeit / Alarmzeit / Alarmstatus)
'-------------------------------------------------------------------------------
'
Alarmstatus:
Gosub Pause
Gosub Cleardis
Di1 = 12 : Di2 = 13                               ' Anzeige 'AL  '
Gosub Pause
Gosub Showalarmtime
Gosub Pause
'
Alarmstatechange:
If Astat = Ein Then
   Gosub X_on : Di1 = 12
End If
If Astat = Aus Then
   Gosub X_off : Di1 = 12
   Asnze = Aus
   Al4tmp = Al4
End If
Gosub Checkbutton
Gosub Checkpause
If A = 100 Then Return                            'Rckkehr ins Hauptprogramm
Astat = Astat Xor 255                             'Invertiert alle 8 Bits
Goto Alarmstatechange
'
'
'
'-------------------------------------------------------------------------------
' Stellfunktionen
'-------------------------------------------------------------------------------
'
Functionsmenu:
Gosub Checkbutton
If A = 100 Then Gosub Setalarm                    'Menpunkt Alarmzeit setzen
Gosub Checkbutton
If A = 100 Then Gosub Settime                     'Menpunkt Systemzeit setzen
Return                                            'oder direkt zurck
'
Setalarm:
Gosub X_set : Di1 = 12                            'Anzeige 'ASET'
Gosub Pause
Gosub Showalarmtime
Gosub Setdigits
Al1 = Di1
Al2 = Di2
Al3 = Di3
Al4 = Di4                                         'eingestellten Alarm bernehmen
Al4tmp = Al4                                      'Alarmminute fr Schlummer
'
Asnze = Aus                                       'Kein Schlummer
'Alarm = Aus                                       'Kein Alarm
Astat = Ein                                       'Alarmstatus einschalten
Return
'
Settime:
Disable Timer1
Gosub X_set                                       'Anzeige 'SET'
Gosub Pause
Gosub Showtime
Gosub Setdigits
Ti1 = Di1
Ti2 = Di2
Ti3 = Di3
Ti4 = Di4
Decr Ti4
While Button = 0 : Wend                           'Sekundengenaues Stellen!
Secs = 59
Load Timer1 , Timer1preset
Enable Timer1                                     'Sekundentimer neu starten
Return
'
'
'
'-------------------------------------------------------------------------------
' Minuten / Stunden Stellmodus fr Uhrzeit und Alarmzeit
'-------------------------------------------------------------------------------
'
Setdigits:
Point = 1
Sethrs:                                           'Stellen der Stunden
Blinkside = 0
Gosub Checkbutton
If A = 100 Then Goto Setmins
Gosub Checkpause
If A = 100 Then Goto Setmins
Incr Di2
If Di2 = 10 Then
   Di2 = 0 : Incr Di1
End If
If Di1 = 2 Then
   If Di2 = 4 Then
   Di2 = 0 : Di1 = 0
   End If
End If
Goto Sethrs
'
Setmins:                                          'Stellen der Minuten
Blinkside = 1
Gosub Checkbutton
If A = 100 Then Goto Setx
Gosub Checkpause
If A = 100 Then Goto Setx
Incr Di4
If Di4 = 10 Then
   Di4 = 0 : Incr Di3
End If
If Di3 = 6 Then Di3 = 0
Goto Setmins
'
Setx:
Blinkside = 4
Return
'
'
'
'-------------------------------------------------------------------------------
' ISR Timer1 - Zeitbasis 1 Hz - Uhr im 24-h-System weiterschalten
'-------------------------------------------------------------------------------
'
Secs_tick:
Load Timer1 , Timer1preset                        'Timer-Voreinstellung laden
Incr Secs                                         'Sekundenzhler erhhen
If Secs > 59 Then                                 'wenn 60. Sekunde erreicht
   Secs = 0                                       'Sekundenzhler zurcksetzen
   Incr Ti4                                       'Minutenzhler um 1 erhhen
End If
'
If Ti4 > 9 Then                                   'Minuten und Stunden
   Ti4 = 0 : Incr Ti3                             'weiterschalten
End If                                            '
If Ti3 > 5 Then                                   'Aus Sicherheitsgrnden
   Ti3 = 0 : Incr Ti2                             'ber Grer-als-Abfragen
End If                                            'gegen Bitfehler
If Ti2 > 9 Then
   Ti2 = 0 : Incr Ti1
End If
If Ti1 > 1 Then
   If Ti2 > 3 Then
   Ti2 = 0 : Ti1 = 0
   End If
End If
'
Alarm = Aus
If Astat <> Ein Then Goto Stexit                  'Alarmstatus ein = Test
If Asnze = Ein Then Goto Stsm                     'Schlummer = nur Minuten testen
If Al1 <> Ti1 Then Goto Stexit                    'Test Stunden-Zehner
If Al2 <> Ti2 Then Goto Stexit                    'Test Stunden-Einer
If Al3 <> Ti3 Then Goto Stexit                    'Test Minuten-Zehner
Stsm:
If Al4tmp = Ti4 Then Alarm = Ein                  'Test Minuten-Einer
'
Stexit:
Return
'
'
'-------------------------------------------------------------------------------
' ISR Timer0 - 7-Segment-Ziffernausgabe und Alarmtonerzeugung
'-------------------------------------------------------------------------------
'
Siebensegment:
Load Timer0 , 160                                 'Interruptfrequenz Preset
Portb = &B11111111                                'Alle Segmente abschalten
If Mains = 0 Then Goto Ssx                        'Bei Netzausfall kein Display
Incr Digit : Digit = Digit And Dimmer             'Zhler fr Ziffern-Multiplex
Portd = &B10100000
Select Case Digit                                 'Ziffer ansteuern (1 bis 4)
   Case 0 : Z4 = 1
         Readeeprom Segbyte , Di1
         If Segbyte = &B11000000 Then Segbyte = &B11111111
         'fhrende Null ausblenden
   Case 1 : Z3 = 1
            Readeeprom Segbyte , Di2
   Case 2 : Z2 = 1
            Readeeprom Segbyte , Di3
   Case 3 : Z1 = 1
            Readeeprom Segbyte , Di4
            Incr Dcntr
End Select
'
B = Digit.1
If B = Blinkside Then
   If Dcntr.6 = 1 Then Segbyte = &B11111111       'Ziffern blinken lassen
End If
If Digit = Point Then Segbyte = Segbyte And 127   'Punkte blinken lassen
If Astat = Ein Then
   If Digit = 3 Then Segbyte = Segbyte And 127    'Alarm-Anzeige-Punkt
End If
'
Ssa:
Portb = Segbyte
'
If Alarm = Ein Then                               'Alarmton mit Interruptfrequenz
     Ddrd.6 = Dcntr.6                             'PORTD.6 aktiv schalten
     Buzzer = Dcntr.6                             'Impulse auf Buzzer geben
End If
'
Ssx:                                              'Anzeigeinterrupt verlassen
Return
'
'
'-------------------------------------------------------------------------------
' Siebensegment-Codes fr Zahlen 0-9 und Sonderzeichen (im EEPROM)
'-------------------------------------------------------------------------------
'
$eeprom
Segmentmuster:
' 0 = Segment eingeschaltet
'      .gfedcba                              'Zeichen       Index
Data &B11000000                                   '0            0
Data &B11111001                                   '1            1
Data &B10100100                                   '2            2
Data &B10110000                                   '3            3
Data &B10011001                                   '4            4
Data &B10010010                                   '5            5
Data &B10000010                                   '6            6
Data &B11111000                                   '7            7
Data &B10000000                                   '8            8
Data &B10010000                                   '9            9
Data &B11111111                                   'alle aus    10
Data &B10001110                                   'F           11
Data &B10001000                                   'A           12
Data &B11000111                                   'L           13
Data &B10000110                                   'E           14
Data &B11001110                                   'T           15
Data &B10100011                                   'o           16
Data &B10101011                                   'n           17
$data
'
'
'-------------------------------------------------------------------------------
'
'